var htmlContent = {
    serverMsgBody: '<div class="clearfix server-message">' +
                           '    <div class="fl name">' +
                           '         [=ServerName=]' +
                           '     </div>' +
                           '     <div class="fl message-text">' +
                           '         [=Message=]' +
                           '     </div>' +
                           '</div>'
}

var options = {
    changeNickname: function () {
        var nickName = prompt(services.nickNameMsg, "").trim();
        while (nickName == '' || nickName.length > 10) {
            nickName = prompt(services.nickNameMsg, "").trim();
        }
        var Data = { uname: nickName, unique_key: services.unique_key };
        jQuery.json("UpdateUname", { url: services.jsonUrl, data: Data, success: function (json, state) {
            if (state) {
                services.uname = nickName;
                localStorage["uname"] = nickName;
            }
            else {
            }
            options.loadFinish();
        }
        });
    },
    deleteData: function () {
        services.uname = '';
        services.unique_key = '';
        localStorage["uname"] = '';
        localStorage["unique_key"] = '';
        services.init();
        options.clearScreen();
        options.loadFinish();
    },
    clearScreen: function () {
        $('#chat-content').html('');
        options.loadFinish();
    },
    translate: function () {
    },
    loadHistory: function () {
    },
    stickyScroll: function () {
    },
    testScript: function () {
        chrome.tabs.executeScript(null,
                           { file: "Core.js" });
        options.loadFinish();
    },
    loadFinish: function () {
        $('.options-menu').slideUp('fast');
        $('#input').focus();
    }
}

var services = {
    website_url: 'http://www.talkingurl.com',
    jsonUrl: 'http://engine.talkingurl.com/json/jsonservices.aspx',
    //jsonUrl: 'http://dev.udi.co.il/talkurl/json/jsonservices.aspx',
    max_input_lenght: 120,
    content: '',
    last_loc: 0,
    current_url: '',
    unique_key: '',
    uname: '',
    loadHistory: 0,
    stickyScroll: 0,
    peopleCount: 0,
    terms_confirmed: 0,
    is_default_tip: 0,
    last_tip_url: '',
    translate_status: 0,
    my_lang: '',
    nickNameMsg: 'Nick name (Up to 10 chars)',
    handleInput: function () {
        var key = event.keyCode;
        var text = $('#input').val().trim();

        $('.options-menu').hide();

        if (text.length > this.max_input_lenght) {
            $('#input').val(text.substring(0, this.max_input_lenght));
            $('#input').trigger('click');
        }

        if (text.length > 40) {
            $('.talkers-list-button').hide();
        }
        else {
            $('.talkers-list-button').show();
        }


        if (key == '13') {
            this.say();
            $('#input').val('');
            $('#input').trigger('click');
            $('.talkers-list-button').show();
        }
    },
    say: function () {
        var text = $('#input').val().trim();
        if (text != '') {
            var Data = { text: text, url: services.current_url, unique_key: services.unique_key };
            jQuery.json("Say", { url: services.jsonUrl, data: Data, success: function (json, state) {
                if (state) {
                    $('#chat-content').html($('#chat-content').html() + '<div>' + json.newchatline + '</div>');
                }
                else {
                    if (json.blockMessage) {
                        $('#chat-content').append(json.blockMessage);
                    }
                }
                var $t = $('#chat-content');
                $t.animate({ scrollTop: 999999 }, 300);
            }
            });
        }
    },
    loadNewMessages: function () {
        var Data = { url: services.current_url, loc: services.last_loc, unique_key: services.unique_key, is_default_tip: services.is_default_tip };
        jQuery.json("UpdateChat", { url: services.jsonUrl, data: Data, success: function (json, state) {
            if (state) {
                if (json.loc) {
                    services.last_loc = json.loc;
                }
                if (json.newcontent) {
                    var content = json.newcontent;
                    if (services.translate_status == 1) {
                        $('.temp-data').html(content);
                        var text = '';
                        $('.temp-data div.text').each(function (index, elem) {
                            text = jQuery.trim($(elem).text());
                            google.language.translate(text, '', services.my_lang, function (result) {
                                if (result.translation) {
                                    $(elem).text(result.translation);
                                    $('#chat-content').append($(elem).parent());
                                    $('#chat-content').animate({ scrollTop: 999999 }, 300);
                                }
                            });
                        });
                        $('.temp-data').html('');
                        //google.language.translate(content, '', services.my_lang, function (result) {
                        //if (result.translation) {
                        //$('#chat-content').append(result.translation);
                        //$('#chat-content').animate({ scrollTop: 999999 }, 300);
                        //}
                        //else {
                        //$('#chat-content').append(content);
                        //}
                        //});
                    }
                    else {
                        $('#chat-content').append(content);
                    }
                    var $t = $('#chat-content');
                    $t.animate({ scrollTop: 999999 }, 300);
                }
                services.updatePeopleCount(json.peopleCount);
                if (json.peopleHtmlList) {
                    $('.people-container').html('<div>' + json.peopleHtmlList + '</div>');
                }
                if (json.newtiprow) {
                    if (json.default_tip == 1 && services.is_default_tip == 1) {
                    }
                    else {
                        if (services.last_tip_url != json.lasturl) {
                            if ($('.tip-row')) {
                                $('.tip-row').animate({ top: '-15px' }, 500);
                            }
                            setTimeout(function () {
                                $('.tip-row-container').html(json.newtiprow);
                                $('.tip-row').animate({ top: '5px' }, 500);
                            }, 500);

                            $('.tip-row-container').animate({ backgroundColor: "#fbf6d9 !important" }, 500);
                            $('.tip-row-container').animate({ backgroundColor: '#eeeeee !important' }, 500);
                            services.last_tip_url = json.lasturl;
                        }
                    }
                    services.is_default_tip = json.default_tip;
                }
                //if (json.privateRequestHtmlList) {
                //    $('#chat-content').append(json.privateRequestHtmlList);
                //    var $t = $('#chat-content');
                //    $t.animate({ scrollTop: 999999 }, 300);
                //}
            }
            else {
            }
            if (services.stickyScroll == 1) {
                var $t = $('#chat-content');
                $t.animate({ scrollTop: 999999 }, 300);
            }
        }
        });
    },
    updatePeopleCount: function (newCount) {
        var newTop = '0px';
        if (newCount > services.peopleCount) {
            $('#spnNum').animate({ top: "-15px" }, 250);
            newTop = '15px';
        }
        else if (newCount < services.peopleCount) {
            $('#spnNum').animate({ top: "15px" }, 250);
            newTop = '-15px';
        }
        services.peopleCount = newCount;
        setTimeout(function () {
            $('#spnCounter').html('<span id=\"spnNum\" style=\"top:' + newTop + '\" class=\"num\">' + (services.peopleCount) + '</span>');
            $('#spnNum').animate({ top: "0px" }, 250);
        }, 250);
    },
    updateChat: function () {
        setInterval("services.loadNewMessages()", 2000);
    },
    animateOver: function (elem) {
        $(elem).mouseenter(
                function () {
                    //$(elem).animate({ borderColor: '#c5d8eb !important' }, 10);
                });
        //$(elem).animate({ borderColor: '#c5d8eb !important' }, 10);
        $(elem).attr('onmouseover', '');
    },
    animateOut: function (elem) {
        $(elem).mouseleave(
                function () {
                    //$(elem).animate({ borderColor: '#eee !important' }, 10);
                });
        //$(elem).animate({ borderColor: '#eee !important' }, 10);
        $(elem).attr('onmouseout', '');
    },
    clickMessage: function (elem, uniqueMessageKey) {
        $(elem).animate({ opacity: '0.3' }, 50);
        $(elem).animate({ opacity: '1' }, 50);
        $(elem).animate({ opacity: '0.3' }, 50);
        $(elem).animate({ opacity: '1' }, 50);
        $(elem).animate({ opacity: '0.3' }, 50);
        $(elem).animate({ opacity: '1' }, 50);

        var Data = { unique_key: services.unique_key, message_key: uniqueMessageKey, url: services.current_url };
        jQuery.json("MessageClick", { url: services.jsonUrl, data: Data, success: function (json, state) {
            if (state) {
                $('#cc_' + uniqueMessageKey).text(json.clickCount);
                $('#cc_' + uniqueMessageKey).show();
                $('#cc_' + uniqueMessageKey).animate({ opacity: '0' }, 2000);
                $(elem).attr('onclick', '');
            }
            else {
            }
        }
        });
    },
    requestPrivate: function (toUniqueKey) {
        var Data = { unique_key: services.unique_key, to_unique_key: toUniqueKey, url: services.current_url };
        jQuery.json("RequestPrivateTalk", { url: services.jsonUrl, data: Data, success: function (json, state) {
            if (state) {
            }
            else {
            }
        }
        });
    },
    confirmPrivate: function (privateTalkKey) {
    },
    sayPrivate: function (privateTalkKey) {
    },
    updatePrivate: function () {
    },
    confirmTerms: function () {
        if ($('#cbTerms:checked').val() == 'on') {
            localStorage["termsConfirmed"] = 1;
            services.terms_confirmed = 1;
            $('#chat-content').html('');
            $('#input').attr('disabled', '');
            $('#input').focus();
            $('.content-loader').fadeOut('fast');
            services.init();
        } else {
            alert("You need to confirm the terms of use.");
        }
    },
    updateMyLang: function (msg) {
        var message_text = '';
        if (msg)
            message_text = msg;
        var Data = { message: message_text };
        jQuery.json("GetUpdateLanguageControl", { url: services.jsonUrl, data: Data, success: function (json, state) {
            if (state) {
                $('#chat-content').append(json.selectLanguageHtml);
                $('#chat-content').animate({ scrollTop: 999999 }, 300);
                if (localStorage["my_lang"]) {
                    $('#ddlLanguages').val(localStorage["my_lang"]);
                }
            }
            else { }
        }
        });
    },
    setLanguage: function () {
        var lang_code = $('#ddlLanguages').val();
        var lang_text = $("#ddlLanguages option[value=" + lang_code + "]").text();
        localStorage["my_lang"] = lang_code;
        services.my_lang = localStorage["my_lang"];
        services.translate_status = 1;
        localStorage["translateStatus"] = 1;
        $('#cbTranslate').attr('checked', 'checked');
        $('.inner-option-lang').css('display', 'block');
        $('.language-selector').fadeOut('fast', function () {
            $('.language-selector').remove();
            services.setServerMessage("Server", "Small Village language set to <span class='green'>" + lang_text + "</span>");
        });
        $('#google-translate-branding').fadeIn();
        $('.google-translate-icon').fadeIn();
        if ($('.promote-sv')) {
            $('.promote-sv').remove();
        }
    },
    setSmallVillageFirstTime: function () {
        services.updateMyLang("What is your small village language?");
    },
    cancelSelectLanguage: function () {
        $('.language-selector').fadeOut('fast', function () {
            $('.language-selector').remove();
        });
        if (services.translate_status == 0) {
            $('#cbTranslate').removeAttr('checked');
        }
    },
    setServerMessage: function (server, message) {
        var content = htmlContent.serverMsgBody;
        content = content.replace("[=ServerName=]", server);
        content = content.replace("[=Message=]", message);
        $('#chat-content').append(content);
        $('#chat-content').animate({ scrollTop: 999999 }, 300);
    },
    init: function () {
        $('#input').attr('disabled', '');
        $('#input').focus();
        $('.content-loader').fadeOut('fast');
        var tc = localStorage["termsConfirmed"];
        if (tc) {
            services.terms_confirmed = tc;
        }
        if (services.terms_confirmed == 0) {
            jQuery.json("GetTermsMessage", { url: services.jsonUrl, data: null, success: function (json, state) {
                if (state) {
                    $('#chat-content').append(json.confirmHtml);
                }
                else { }
            }
            });
        }
		
        else {
            $('#input').attr('disabled', 'disabled');
            chrome.tabs.getSelected(null, function (tab) {
                services.current_url = tab.url;
                $('#btnOptions').bind('click', function () {
                    $('.options-menu').slideToggle('fast');
                });

                $('.connected-people-container').hide();
                $('.global-container').css('width', '286px');

                if (localStorage["talkersWinStatus"]) {
                    if (localStorage["talkersWinStatus"] == 1) {
                        $('.connected-people-container').show();
                        $('.global-container').css('width', '439px');
                        $('.tip-row-container').css('width', '429px');
                    }
                    else {
                        $('.tip-row-container').css('width', '276px');
                    }
                }
                else {
                    localStorage["talkersWinStatus"] = 1;
                    $('.connected-people-container').show();
                    $('.global-container').css('width', '439px');
                }

                $('.talkers-list-button').bind('click', function () {
                    if ($('.connected-people-container').css('display') == 'none') {
                        $('.connected-people-container').show();
                        $('.tip-row-container').css('width', '429px');
                        $('.global-container').css('width', '439px');
                        localStorage["talkersWinStatus"] = 1;
                    }
                    else {
                        $('.connected-people-container').hide();
                        $('.tip-row-container').css('width', '276px');
                        $('.global-container').css('width', '286px');
                        localStorage["talkersWinStatus"] = 0;
                    }
                    $('#input').focus();
                    options.loadFinish();
                });

                services.uname = localStorage["uname"];
                services.unique_key = localStorage["unique_key"];

                if (!services.uname) {
                    var nickname = prompt(services.nickNameMsg, "").trim();
                    while (nickname == '' || nickname.length > 10) {
                        nickname = prompt(services.nickNameMsg, "").trim();
                    }
                    services.uname = nickname;
                    localStorage["uname"] = nickname;
                }

                var lh = localStorage["loadHistory"];
                var ss = localStorage["stickyScroll"];

                if (lh) {
                    if (lh == 1) {
                        services.loadHistory = 1;
                        $('#cbLoadHistory').attr('checked', 'checked');
                    }
                }
                else {
                    services.loadHistory = 1;
                    $('#cbLoadHistory').attr('checked', 'checked');
                    localStorage["loadHistory"] = 1;
                }
                if (ss) {
                    if (ss == 1) {
                        services.stickyScroll = 1;
                        $('#cbStickyScroll').attr('checked', 'checked');
                    }
                }
                else {
                    services.stickyScroll = 0;
                    localStorage["stickyScroll"] = 0;
                }
                var Data = { unique_key: services.unique_key, uname: services.uname, url: services.current_url, loadHistory: services.loadHistory, lang: services.my_lang };
                jQuery.json("GetClientUniqueKey", { url: services.jsonUrl, data: Data, success: function (json, state) {
                    if (state) {
                        services.updatePeopleCount(json.peopleCount);
                        services.unique_key = json.unique_key;
                        localStorage["unique_key"] = json.unique_key;
                        services.last_loc = json.location;
                        if (services.loadHistory) {
                            $('#chat-content').append(json.lastcontent);
                        }
                        if (json.publicServerMessage) {
                            $('#chat-content').append(json.publicServerMessage);
                        }
                        if (json.smallVillagePromote) {
                            $('#chat-content').append(json.smallVillagePromote);
                        }
                        if (services.stickyScroll == 1) {
                            var $t = $('#chat-content');
                            $t.animate({ scrollTop: 999999 }, 300);
                        }
                        services.updateChat();
                        var $t = $('#chat-content');
                        $t.animate({ scrollTop: 999999 }, 300);
                    }
                    else {
                    }
                    $('#input').attr('disabled', '');
                    $('#input').focus();
                    $('.content-loader').fadeOut('fast');
                }
                });

                $('#chat-content').mouseleave(function () {
                    $('#input').focus();
                });

                $('#cbLoadHistory').change(function () {
                    if ($('#cbLoadHistory:checked').val() == 'on') {
                        services.loadHistory = 1;
                        localStorage["loadHistory"] = 1;
                    }
                    else {
                        services.loadHistory = 0;
                        localStorage["loadHistory"] = 0;
                    }
                });
                $('#cbStickyScroll').change(function () {
                    if ($('#cbStickyScroll:checked').val() == 'on') {
                        services.stickyScroll = 1;
                        localStorage["stickyScroll"] = 1;
                    }
                    else {
                        services.stickyScroll = 0;
                        localStorage["stickyScroll"] = 0;
                    }
                });
                $('#cbTranslate').change(function () {
                    if ($('#cbTranslate:checked').val() == 'on') {
                        options.loadFinish();
                        $('.inner-option-lang').css('display', 'block');
                        localStorage["translateStatus"] = 1;
                        services.translate_status = 1;
                        if (localStorage["my_lang"] == '') {
                            services.updateMyLang('What is your small village language?');
                        }
                        else {
                            services.setServerMessage("Server", "Small Village mode turned <span class='green'>on</span>");
                        }
                        $('#google-translate-branding').fadeIn();
                        $('.google-translate-icon').fadeIn();
                    }
                    else {
                        $('.inner-option-lang').css('display', 'none');
                        localStorage["translateStatus"] = 0;
                        services.translate_status = 0;
                        services.setServerMessage("Server", "Small Village mode turned <span class='red'>off</span>");
                        $('#google-translate-branding').fadeOut();
                        $('.google-translate-icon').fadeOut();
                    }
                });
                var $t = $('#chat-content');
                $t.animate({ scrollTop: 999999 }, 300);
				
            });
        }
    }
	
}

jQuery.json = function (command, options) {
    if (typeof command === 'undefined') { $.setException('jQuery.json', 'no command has been set'); }
    options = options || {};
    options.url = options.url || '';
    options.data = options.data || {};
    options.type = options.type || 'POST';
    options.success = options.success || function () { };

    options.data.Command = command;
    $.ajax({
        url: options.url + '?Command=' + command, data: options.data, type: options.type,
        success: function (data) {
            var json = jQuery.parseJSON(data);
            options.success(json, json.state);
        }
    });

};
jQuery.getControlFromJson = function (json, controlName) {
    return json.content[controlName];
};
jQuery.fn.appendControl = function (control) {
    this.append(control.html);
};

function initialize() {
    var ts = localStorage["translateStatus"];
    if (ts) {
        if (ts == 1) {
            $('.inner-option-lang').css('display', 'block');
            services.translate_status = 1;
            $('#cbTranslate').attr('checked', 'checked');
            services.my_lang = localStorage["my_lang"];
            google.language.getBranding('google-translate-branding');
            $('#google-translate-branding').fadeIn();
            $('.google-translate-icon').fadeIn();
        }
    }
    else {
        $('.inner-option-lang').css('display', 'none');
        services.translate_status = 0;
        localStorage["translateStatus"] = 0;
        $('#google-translate-branding').fadeOut();
        $('.google-translate-icon').fadeOut();
    }
}